function [y1,y2]=validation1(x,I,n,J,xvar,xsd);

%input is a column vector of I*n*J rows, with I replicated spots together. Total pairs is
%n, on J arrays. xsd is n*J sample standard deviation matrix. xvar is n*J
%sample variance matrix.

x1=reshape(x,I,n*J);
x3=reshape(x,I*n,J);

x2=mean(x1,1);
x2=reshape(x2,n,J);

y1=zeros(J,1);
y2=zeros(J,1);

for j=1:J;
    for i=1:n;
        y1(j)=y1(j)+sum((x3(I*(i-1)+1:I*i,j)-x2(i,j)).^2)/xvar(i,j);        %chi-square T_1
         
        y2(j)=y2(j)+sum(abs(x3(I*(i-1)+1:I*i,j)-x2(i,j)))/sqrt(2/3)/xsd(i,j);  %L1-norm
    end;
end;

y2=sqrt(n)*(y2/n-3*sqrt(2/pi))/1.2563;               %approx. normal distribution T_2