function [y1,y2]=validation2(x,I,n,J,xvar,xsd);

%input is a column vector of I*n*J rows, with I replicated spots together. Total pairs is
%n, on J arrays. xsd is n*J sample standard deviation matrix. xvar is n*J
%sample variance matrix.

x1=reshape(x,I,n*J);
x3=reshape(x,I*n,J);

x2=mean(x1,1);
x2=reshape(x2,n,J);

y1=zeros(J,1);
y2=zeros(J,1);

for j=1:J;
    for i=1:n;
        y1(j)=y1(j)+sum((x3(I*(i-1)+1:I*i,j)-x2(i,j)).^2);        %chi-square  
         
        y2(j)=y2(j)+sum(abs(x3(I*(i-1)+1:I*i,j)-x2(i,j)));         %L1-norm
        
    end;
end;

sd_sum=sum(xvar);
sd_sumsq=sum(xvar.^2);
sd_sumt=sum(xsd);

for j=1:J;
y1(j)=(y1(j)-2*sd_sum(j))/sqrt(4*sd_sumsq(j));            %T_3

y2(j)=(y2(j)-sqrt(12/pi)*sd_sumt(j))/sqrt(1.0523*sd_sum(j)); %T_4

end;